require 'rubygems'
require 'nokogiri'
require 'open-uri'
require 'uri'

class BookPrice
    class << self
        def kingStone(isbn, par)
            search_url = "http://www.kingstone.com.tw/search/result.asp?c_name=#{isbn}&se_type=4"
            search_page = Nokogiri::HTML(open(search_url))
            result_url = search_page.css("#mainContent .row_list ul li:nth-child(1) a.anchor").map{|link| "http://www.kingstone.com.tw/" + link['href']}[0]
            result_page = Nokogiri::HTML(open(result_url))
            par = par.split('')
            rtn_hash = {}
            par.each do |value|
                case value
                when 'p'
                    price = result_page.css("#mainContent div.item_info li.cross em b").text.gsub("元", "").strip
                    rtn_hash.store("price", price)
                when 'n'
                    name = result_page.css("#mainContent div.item_info h1").text.strip
                    rtn_hash.store("name", name)
                when 'd'
                    discount = result_page.css("#mainContent div.item_info ul li:nth-child(10) b.dis_p").text
                    rtn_hash.store("discount", discount)
                else
                    raise 'wrong parameter'
                end
            end
            return rtn_hash
        end

        def eslite(isbn, par)
            search_url = "http://www.eslite.com/Search_BW.aspx?query=#{isbn}"
            search_page = Nokogiri::HTML(open(search_url))
            result_url = search_page.css("#ctl00_ContentPlaceHolder1_searchResult div.box_list table tr:nth-child(1) td.name a:nth-child(2)").map{|link| link['href']}[0]
            result_page = Nokogiri::HTML(open(result_url))
            par = par.split('')
            rtn_hash = {}
            par.each do |value|
                case value
                when 'p'

                    price = result_page.css("#ctl00_ContentPlaceHolder1_product_info div.Mboxes_cont div.PI_info .price").text
                    rtn_hash.store("price", price)
                when 'n'
                    name = result_page.css("#ctl00_ContentPlaceHolder1_lblProductName").text.strip
                    rtn_hash.store("name", name)
                when 'd'
                    discount = result_page.css("#ctl00_ContentPlaceHolder1_product_info div.Mboxes_cont div.PI_info span.price_sale:nth-child(2)").text
                    rtn_hash.store("discount", discount)
                else
                    raise 'wrong parameter'
                end
            end
            return rtn_hash
        end

        def books(isbn, par)
            search_url = "http://search.books.com.tw/exep/prod_search.php?key=#{isbn}&cat=all"
            search_page = Nokogiri::HTML(open(search_url))
            tmp_book_url = search_page.css("#searchlist > ul li:nth-child(1) h3 a").map{ |a| a['href'] }[0]
            item_id = tmp_book_url.match(/item.........../).to_s.split("=")[1]
            result_url = "http://www.books.com.tw/products/#{item_id}"
            result_page = Nokogiri::HTML(open(result_url))
            par = par.split('')
            rtn_hash = {}
            par.each do |value|
                case value
                when 'p'
                    price = result_page.css(".price li:nth-child(1) em").text
                    rtn_hash.store("price", price)
                when 'n'
                    name = result_page.css("div.mod.type02_p01_wrap.clearfix div.grid_10 div.mod.type02_p002.clearfix h1").text.strip
                    rtn_hash.store("name", name)
                when 'd'
                    discount = result_page.css(".prod_cont_a .price li:nth-child(2) strong:nth-child(2) b").text
                    rtn_hash.store("discount", discount)
                else
                    raise 'wrong parameter'
                end
            end
            return rtn_hash
        end
    end
end
